const int sensor1Pin = 2; // Pin para Sensor1
const int sensor2Pin = 3; // Pin para Sensor2
const int sirenPin = 4;   // Pin para la Sirena
const unsigned long delayTime = 3000; // Tiempo de espera de 3 segundos

unsigned long sensor2Time = 0;
bool waitingForSensor1 = false;

void setup() {
  pinMode(sensor1Pin, INPUT);
  pinMode(sensor2Pin, INPUT);
  pinMode(sirenPin, OUTPUT);
  digitalWrite(sirenPin, LOW);
  Serial.begin(9600);
}

void loop() {
  bool sensor1Current = digitalRead(sensor1Pin);
  bool sensor2Current = digitalRead(sensor2Pin);

  Serial.print("Sensor1: ");
  Serial.print(sensor1Current);
  Serial.print(" | Sensor2: ");
  Serial.println(sensor2Current);

  // Si Sensor2 cambia a 0, empezar a esperar que Sensor1 cambie a 0
  if (!sensor2Current && waitingForSensor1) {
    waitingForSensor1 = false;
    sensor2Time = millis(); // Registrar el tiempo cuando Sensor2 se desactiva
    Serial.println("Sensor2 desactivado, esperando Sensor1...");
  }

  // Si Sensor2 estaba esperando a Sensor1 y ahora Sensor1 cambia a 0 dentro del tiempo
  if (!sensor1Current && !sensor2Current && !waitingForSensor1 && millis() - sensor2Time <= delayTime) {
    Serial.println("Condición cumplida: Sensor2 luego Sensor1 dentro del tiempo. Sirena ENCENDIDA.");
    
    // Sonido intermitente de la sirena durante 5 segundos
    for (int i = 0; i < 10; i++) { 
      digitalWrite(sirenPin, HIGH);
      delay(250); // Sirena encendida por 0.25 segundos
      digitalWrite(sirenPin, LOW);
      delay(250); // Sirena apagada por 0.25 segundos
    }
    Serial.println("Sirena APAGADA.");
  }

  // Detectar cambio de Sensor1 de 0 a 1
  if (sensor1Current && !sensor2Current) {
    waitingForSensor1 = true; // Esperar a que Sensor2 se desactive
    Serial.println("Sensor1 activado, esperando a que Sensor2 se desactive...");
  }

  // Detectar cambio de Sensor2 de 0 a 1
  if (sensor2Current && !sensor1Current) {
    waitingForSensor1 = false; // No esperar a Sensor1, se activó el sensor 2 solo
    Serial.println("Sensor2 activado, esperando a que Sensor1 se desactive...");
  }

  // Resetear si el tiempo de espera expira sin que ambos sensores estén inactivos
  if (waitingForSensor1 && millis() - sensor2Time > delayTime) {
    waitingForSensor1 = false; // Reiniciar estado para esperar nueva desactivación de Sensor2
  }

  delay(1000); // Pequeño retraso para evitar salida serial rápida
}
